1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
84 my $ok = join("|", qw(
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
101 GIT_AUTHOR_EMAIL=author@example.com
102 GIT_AUTHOR_NAME='A U Thor'
103 GIT_COMMITTER_EMAIL=committer@example.com
104 GIT_COMMITTER_NAME='C O Mitter'
105 GIT_MERGE_VERBOSITY=5
106 GIT_MERGE_AUTOEDIT=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
112 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
114 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
115 export GIT_INDEX_VERSION
118 # Add libc MALLOC and MALLOC_PERTURB test
119 # only if we are not executing the test with valgrind
120 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
121 test -n "$TEST_NO_MALLOC_CHECK"
123 setup_malloc_check () {
126 teardown_malloc_check () {
130 setup_malloc_check () {
131 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
132 export MALLOC_CHECK_ MALLOC_PERTURB_
134 teardown_malloc_check () {
135 unset MALLOC_CHECK_ MALLOC_PERTURB_
139 # Protect ourselves from common misconfiguration to export
140 # CDPATH into the environment
146 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
148 echo "* warning: Some tests will not work if GIT_TRACE" \
149 "is set as to trace on STDERR ! *"
150 echo "* warning: Please set GIT_TRACE to something" \
151 "other than 1, 2 or true ! *"
157 # A regexp to match 5 and 40 hexdigits
158 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
159 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
162 _z40=0000000000000000000000000000000000000000
168 export _x05 _x40 _z40 LF
170 # Each test should start with something like this, after copyright notices:
172 # test_description='Description of this test...
173 # This test checks if command xyzzy does the right thing...
176 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
177 TERM=$ORIGINAL_TERM &&
180 tput bold >/dev/null 2>&1 &&
181 tput setaf 1 >/dev/null 2>&1 &&
182 tput sgr0 >/dev/null 2>&1
186 while test "$#" -ne 0
189 -d|--d|--de|--deb|--debu|--debug)
191 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
192 immediate=t; shift ;;
193 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
194 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
195 -h|--h|--he|--hel|--help)
197 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
200 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
202 -q|--q|--qu|--qui|--quie|--quiet)
203 # Ignore --quiet under a TAP::Harness. Saying how many tests
204 # passed without the ok/not ok details is always an error.
205 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
207 with_dashes=t; shift ;;
210 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
214 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
217 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
220 shift ;; # was handled already
222 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
225 echo "error: unknown test option '$1'" >&2; exit 1 ;;
229 if test -n "$valgrind_only"
231 test -z "$valgrind" && valgrind=memcheck
232 test -z "$verbose" && verbose_only="$valgrind_only"
233 elif test -n "$valgrind"
246 tput bold; tput setaf 1;; # bold red
248 tput setaf 4;; # blue
250 tput setaf 3;; # brown/yellow
252 tput setaf 2;; # green
254 tput setaf 6;; # cyan
256 test -n "$quiet" && return;;
266 test -z "$1" && test -n "$quiet" && return
273 say_color error "error: $*"
282 test "${test_description}" != "" ||
283 error "Test script did not set test_description."
285 if test "$help" = "t"
287 printf '%s\n' "$test_description"
293 if test "$verbose" = "t"
297 exec 4>/dev/null 3>/dev/null
306 test_external_has_tap=0
310 if test -n "$GIT_EXIT_OK"
314 echo >&5 "FATAL: Unexpected exit with code $code"
322 # The user-facing functions are loaded from a separate file so that
323 # test_perf subshells can have them too
324 . "$TEST_DIRECTORY/test-lib-functions.sh"
326 # You are not expected to call test_ok_ and test_failure_ directly, use
327 # the test_expect_* functions instead.
330 test_success=$(($test_success + 1))
331 say_color "" "ok $test_count - $@"
335 test_failure=$(($test_failure + 1))
336 say_color error "not ok $test_count - $1"
338 printf '%s\n' "$*" | sed -e 's/^/# /'
339 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
342 test_known_broken_ok_ () {
343 test_fixed=$(($test_fixed+1))
344 say_color error "ok $test_count - $@ # TODO known breakage vanished"
347 test_known_broken_failure_ () {
348 test_broken=$(($test_broken+1))
349 say_color warn "not ok $test_count - $@ # TODO known breakage"
353 test "$debug" = "" || eval "$1"
356 match_pattern_list () {
359 test -z "$*" && return 1
370 maybe_teardown_verbose () {
371 test -z "$verbose_only" && return
372 exec 4>/dev/null 3>/dev/null
377 maybe_setup_verbose () {
378 test -z "$verbose_only" && return
379 if match_pattern_list $test_count $verbose_only
382 # Emit a delimiting blank line when going from
383 # non-verbose to verbose. Within verbose mode the
384 # delimiter is printed by test_expect_*. The choice
385 # of the initial $last_verbose is such that before
386 # test 1, we do not print it.
387 test -z "$last_verbose" && echo >&3 ""
390 exec 4>/dev/null 3>/dev/null
393 last_verbose=$verbose
396 maybe_teardown_valgrind () {
397 test -z "$GIT_VALGRIND" && return
398 GIT_VALGRIND_ENABLED=
401 maybe_setup_valgrind () {
402 test -z "$GIT_VALGRIND" && return
403 if test -z "$valgrind_only"
405 GIT_VALGRIND_ENABLED=t
408 GIT_VALGRIND_ENABLED=
409 if match_pattern_list $test_count $valgrind_only
411 GIT_VALGRIND_ENABLED=t
416 # This is a separate function because some tests use
417 # "return" to end a test_expect_success block early.
418 eval </dev/null >&3 2>&4 "$*"
427 teardown_malloc_check
429 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
432 test_eval_ "$test_cleanup"
433 teardown_malloc_check
435 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
443 test_count=$(($test_count+1))
450 maybe_teardown_valgrind
451 maybe_teardown_verbose
456 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
460 if test -z "$to_skip" && test -n "$test_prereq" &&
461 ! test_have_prereq "$test_prereq"
468 if test "$missing_prereq" != "$test_prereq"
470 of_prereq=" of $test_prereq"
473 say_color skip >&3 "skipping test: $@"
474 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
483 # stub; perf-lib overrides it
484 test_at_end_hook_ () {
491 if test -z "$HARNESS_ACTIVE"
493 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
494 mkdir -p "$test_results_dir"
496 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
498 cat >>"$test_results_path" <<-EOF
500 success $test_success
508 if test "$test_fixed" != 0
510 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
512 if test "$test_broken" != 0
514 say_color warn "# still have $test_broken known breakage(s)"
516 if test "$test_broken" != 0 || test "$test_fixed" != 0
518 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
519 msg="remaining $test_remaining test(s)"
521 test_remaining=$test_count
522 msg="$test_count test(s)"
524 case "$test_failure" in
526 # Maybe print SKIP message
527 if test -n "$skip_all" && test $test_count -gt 0
529 error "Can't use skip_all after running some tests"
531 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
533 if test $test_external_has_tap -eq 0
535 if test $test_remaining -gt 0
537 say_color pass "# passed all $msg"
539 say "1..$test_count$skip_all"
542 test -d "$remove_trash" &&
543 cd "$(dirname "$remove_trash")" &&
544 rm -rf "$(basename "$remove_trash")"
551 if test $test_external_has_tap -eq 0
553 say_color error "# failed $test_failure among $msg"
562 if test -n "$valgrind"
566 test "$1" = "$(readlink "$2")" || {
574 while test -d "$2".lock
576 say "Waiting for lock on $2."
583 make_valgrind_symlink () {
584 # handle only executables, unless they are shell libraries that
585 # need to be in the exec-path.
587 test "# " = "$(head -c 2 <"$1")" ||
590 base=$(basename "$1")
591 symlink_target=$GIT_BUILD_DIR/$base
592 # do not override scripts
593 if test -x "$symlink_target" &&
594 test ! -d "$symlink_target" &&
595 test "#!" != "$(head -c 2 < "$symlink_target")"
597 symlink_target=../valgrind.sh
601 symlink_target=../unprocessed-script
603 # create the link, or replace it if it is out of date
604 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
607 # override all git executables in TEST_DIRECTORY/..
608 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
609 mkdir -p "$GIT_VALGRIND"/bin
610 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
612 make_valgrind_symlink $file
614 # special-case the mergetools loadables
615 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
620 ls "$path"/git-* 2> /dev/null |
623 make_valgrind_symlink "$file"
627 PATH=$GIT_VALGRIND/bin:$PATH
628 GIT_EXEC_PATH=$GIT_VALGRIND/bin
630 GIT_VALGRIND_MODE="$valgrind"
631 export GIT_VALGRIND_MODE
632 GIT_VALGRIND_ENABLED=t
633 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
634 export GIT_VALGRIND_ENABLED
635 elif test -n "$GIT_TEST_INSTALLED"
637 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
638 error "Cannot run git from $GIT_TEST_INSTALLED."
639 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
640 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
641 else # normal case, use ../bin-wrappers only unless $with_dashes:
642 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
643 if ! test -x "$git_bin_dir/git"
645 if test -z "$with_dashes"
647 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
651 PATH="$git_bin_dir:$PATH"
652 GIT_EXEC_PATH=$GIT_BUILD_DIR
653 if test -n "$with_dashes"
655 PATH="$GIT_BUILD_DIR:$PATH"
658 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
659 GIT_CONFIG_NOSYSTEM=1
661 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
663 if test -z "$GIT_TEST_CMP"
665 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
667 GIT_TEST_CMP="$DIFF -c"
669 GIT_TEST_CMP="$DIFF -u"
673 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
675 test -d "$GIT_BUILD_DIR"/templates/blt || {
676 error "You haven't built things yet, have you?"
679 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
681 echo >&2 'You need to build test-chmtime:'
682 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
687 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
688 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
689 case "$TRASH_DIRECTORY" in
690 /*) ;; # absolute path is good
691 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
693 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
694 rm -fr "$TRASH_DIRECTORY" || {
696 echo >&5 "FATAL: Cannot prepare test area"
700 HOME="$TRASH_DIRECTORY"
703 if test -z "$TEST_NO_CREATE_REPO"
705 test_create_repo "$TRASH_DIRECTORY"
707 mkdir -p "$TRASH_DIRECTORY"
709 # Use -P to resolve symlinks in our working directory so that the cwd
710 # in subprocesses like git equals our $PWD (for pathname comparisons).
711 cd -P "$TRASH_DIRECTORY" || exit 1
714 this_test=${this_test%%-*}
715 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
717 say_color info >&3 "skipping test $this_test altogether"
718 skip_all="skip all tests in $this_test"
722 # Provide an implementation of the 'yes' utility
737 # Fix some commands on Windows
740 # Windows has its own (incompatible) sort and find
750 # git sees Windows-style pwd
754 # no POSIX permissions
755 # backslashes in pathspec are converted to '/'
756 # exec does not inherit the PID
757 test_set_prereq MINGW
758 test_set_prereq NOT_CYGWIN
759 test_set_prereq SED_STRIPS_CR
760 test_set_prereq GREP_STRIPS_CR
761 GIT_TEST_CMP=mingw_test_cmp
764 test_set_prereq POSIXPERM
765 test_set_prereq EXECKEEPSPID
766 test_set_prereq NOT_MINGW
767 test_set_prereq CYGWIN
768 test_set_prereq SED_STRIPS_CR
769 test_set_prereq GREP_STRIPS_CR
772 test_set_prereq POSIXPERM
773 test_set_prereq BSLASHPSPEC
774 test_set_prereq EXECKEEPSPID
775 test_set_prereq NOT_MINGW
776 test_set_prereq NOT_CYGWIN
780 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
781 test -z "$NO_PERL" && test_set_prereq PERL
782 test -z "$NO_PYTHON" && test_set_prereq PYTHON
783 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
784 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
786 # Can we rely on git's output in the C locale?
787 if test -n "$GETTEXT_POISON"
789 GIT_GETTEXT_POISON=YesPlease
790 export GIT_GETTEXT_POISON
791 test_set_prereq GETTEXT_POISON
793 test_set_prereq C_LOCALE_OUTPUT
796 # Use this instead of test_cmp to compare files that contain expected and
797 # actual output from git commands that can be translated. When running
798 # under GETTEXT_POISON this pretends that the command produced expected
801 test -n "$GETTEXT_POISON" || test_cmp "$@"
804 # Use this instead of "grep expected-string actual" to see if the
805 # output from a git command that can be translated either contains an
806 # expected string, or does not contain an unwanted one. When running
807 # under GETTEXT_POISON this pretends that the command produced expected
810 if test -n "$GETTEXT_POISON"
813 elif test "x!" = "x$1"
822 test_lazy_prereq PIPE '
823 # test whether the filesystem supports FIFOs
829 rm -f testfifo && mkfifo testfifo
834 test_lazy_prereq SYMLINKS '
835 # test whether the filesystem supports symbolic links
836 ln -s x y && test -h y
839 test_lazy_prereq FILEMODE '
840 test "$(git config --bool core.filemode)" = true
843 test_lazy_prereq CASE_INSENSITIVE_FS '
844 echo good >CamelCase &&
845 echo bad >camelcase &&
846 test "$(cat CamelCase)" != good
849 test_lazy_prereq UTF8_NFD_TO_NFC '
850 # check whether FS converts nfd unicode to nfc
851 auml=$(printf "\303\244")
852 aumlcdiar=$(printf "\141\314\210")
862 test_lazy_prereq AUTOIDENT '
863 sane_unset GIT_AUTHOR_NAME &&
864 sane_unset GIT_AUTHOR_EMAIL &&
865 git var GIT_AUTHOR_IDENT
868 # When the tests are run as root, permission tests will report that
869 # things are writable when they shouldn't be.
870 test -w / || test_set_prereq SANITY
872 GIT_UNZIP=${GIT_UNZIP:-unzip}
873 test_lazy_prereq UNZIP '